#define _POSIX_C_SOURCE 200112L
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

#define TAILLE 1024
int main(int argc, char *argv[]){

  int fd1, fd2, rc, wc;
  char tamp[TAILLE];

  if( argc != 3 ){
    fprintf(stderr,"usage: %s fichier1 fichier2\n", argv[0]);
    exit(1);
  }

  if ( ( fd1 = open(argv[1],O_RDONLY) ) < 0 ){
    perror("open fichier1");
    exit(1);
  }

  if( ( fd2 = open(argv[2],O_WRONLY | O_CREAT | O_TRUNC,  
		   S_IRWXU | S_IRWXG | S_IRWXO ) ) < 0 ){
    perror("open fichier2");
    exit(1);
  }

  for( ;; ){
    rc = read(fd1, &tamp, sizeof tamp);
    if( rc < 0 ){
      perror("read");
      exit(1);
    }
    if( rc == 0 )
      break;

    wc=write(fd2, &tamp, rc);
    if( wc < 0 ){
      perror("write");
      exit(1);
    }

    if( wc != rc ){
      fprintf( stderr,"probleme ecriture\n");
      exit(2);
    }

    /* l'instruction suivante peut etre supprimee*/
    if( rc < sizeof tamp )
      break;

  }
  close(fd1);
  close(fd2);
}
